diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/global-value.cc ns-3.31/src/core/model/global-value.cc
--- ns-3.30.1/src/core/model/global-value.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/global-value.cc	2020-06-27 17:38:30.000000000 -0700
@@ -25,9 +25,10 @@
 #include "log.h"
 
 #include "ns3/core-config.h"
-#ifdef HAVE_STDLIB_H
-#include <cstdlib>
-#endif
+
+#include <cstdlib>  // getenv
+#include <cstring>  // strlen
+
 
 /**
  * \file
@@ -67,24 +68,24 @@
 GlobalValue::InitializeFromEnv (void)
 {
   NS_LOG_FUNCTION (this);
-#ifdef HAVE_GETENV
-  char *envVar = getenv ("NS_GLOBAL_VALUE");
-  if (envVar == 0)
+
+  const char *envVar = getenv ("NS_GLOBAL_VALUE");
+  if (envVar == 0 || std::strlen (envVar) == 0)
     {
       return;
     }
-  std::string env = std::string (envVar);
+  std::string env = envVar;
   std::string::size_type cur = 0;
   std::string::size_type next = 0;
   while (next != std::string::npos)
     {
       next = env.find (";", cur);
-      std::string tmp = std::string (env, cur, next-cur);
+      std::string tmp = std::string (env, cur, next - cur);
       std::string::size_type equal = tmp.find ("=");
       if (equal != std::string::npos)
         {
           std::string name = tmp.substr (0, equal);
-          std::string value = tmp.substr (equal+1, tmp.size () - equal - 1);
+          std::string value = tmp.substr (equal + 1, tmp.size () - equal - 1);
           if (name == m_name)
             {
               Ptr<AttributeValue> v = m_checker->CreateValidValue (StringValue (value));
@@ -98,16 +99,15 @@
         }
       cur = next + 1;
     }
-#endif /* HAVE_GETENV */
 }
 
-std::string 
+std::string
 GlobalValue::GetName (void) const
 {
   NS_LOG_FUNCTION_NOARGS ();
   return m_name;
 }
-std::string 
+std::string
 GlobalValue::GetHelp (void) const
 {
   NS_LOG_FUNCTION_NOARGS ();
@@ -125,11 +125,11 @@
   StringValue *str = dynamic_cast<StringValue *> (&value);
   if (str == 0)
     {
-      NS_FATAL_ERROR ("GlobalValue name="<<m_name<<": input value is not a string");
+      NS_FATAL_ERROR ("GlobalValue name=" << m_name << ": input value is not a string");
     }
   str->Set (m_currentValue->SerializeToString (m_checker));
 }
-Ptr<const AttributeChecker> 
+Ptr<const AttributeChecker>
 GlobalValue::GetChecker (void) const
 {
   NS_LOG_FUNCTION (this);
@@ -151,7 +151,7 @@
   return true;
 }
 
-void 
+void
 GlobalValue::Bind (std::string name, const AttributeValue &value)
 {
   NS_LOG_FUNCTION (name << &value);
@@ -162,14 +162,14 @@
         {
           if (!(*i)->SetValue (value))
             {
-              NS_FATAL_ERROR ("Invalid new value for global value: "<<name);
+              NS_FATAL_ERROR ("Invalid new value for global value: " << name);
             }
           return;
         }
     }
-  NS_FATAL_ERROR ("Non-existant global value: "<<name);
+  NS_FATAL_ERROR ("Non-existant global value: " << name);
 }
-bool 
+bool
 GlobalValue::BindFailSafe (std::string name, const AttributeValue &value)
 {
   NS_LOG_FUNCTION (name << &value);
@@ -183,21 +183,21 @@
     }
   return false;
 }
-GlobalValue::Iterator 
+GlobalValue::Iterator
 GlobalValue::Begin (void)
 {
   NS_LOG_FUNCTION_NOARGS ();
 
   return GetVector ()->begin ();
 }
-GlobalValue::Iterator 
+GlobalValue::Iterator
 GlobalValue::End (void)
 {
   NS_LOG_FUNCTION_NOARGS ();
   return GetVector ()->end ();
 }
 
-void 
+void
 GlobalValue::ResetInitialValue (void)
 {
   NS_LOG_FUNCTION (this);
@@ -215,7 +215,7 @@
           (*gvit)->GetValue (value);
           return true;
         }
-    } 
+    }
   return false; // not found
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/global-value.h ns-3.31/src/core/model/global-value.h
--- ns-3.30.1/src/core/model/global-value.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/global-value.h	2020-06-27 17:38:30.000000000 -0700
@@ -33,11 +33,11 @@
 
 namespace ns3 {
 
-  /* Forward declaration */
-  namespace tests {
-    class GlobalValueTestCase;
-  }
-  
+/* Forward declaration */
+namespace tests {
+class GlobalValueTestCase;
+}
+
 /**
  * \ingroup Core
  *
@@ -49,7 +49,7 @@
  *   - From the command line,
  *   - By explicit call to SetValue() or Bind().
  *
- * Instances of this class are expected to be allocated as static 
+ * Instances of this class are expected to be allocated as static
  * global variables and should be used to store configurable global state.
  * For example:
  * \code
@@ -64,9 +64,9 @@
  * but they can also be set through the \c NS_GLOBAL_VALUE environment variable.
  * For example, \c NS_GLOBAL_VALUE='Name=Value;OtherName=OtherValue;' would set
  * global values \c Name and \c OtherName to \c Value and \c OtherValue,
- * respectively. 
+ * respectively.
  *
- * Users of the CommandLine class also get the ability to set global 
+ * Users of the CommandLine class also get the ability to set global
  * values through command line arguments to their program:
  * \c --Name=Value will set global value \c Name to \c Value.
  */
@@ -74,7 +74,7 @@
 {
   /** Container type for holding all the GlobalValues. */
   typedef std::vector<GlobalValue *> Vector;
-  
+
 public:
   /** Iterator type for the list of all global values. */
   typedef Vector::const_iterator Iterator;
@@ -160,31 +160,30 @@
   static Iterator End (void);
 
 
-  /** 
+  /**
    * Finds the GlobalValue with the given name and returns its value
-   * 
+   *
    * \param [in] name the name of the GlobalValue to be found
    * \param [out] value where to store the value of the found GlobalValue
-   * 
+   *
    * \return \c true if the GlobalValue was found, \c false otherwise
    */
   static bool GetValueByNameFailSafe (std::string name, AttributeValue &value);
 
-  /** 
+  /**
    * Finds the GlobalValue with the given name and returns its
    * value.
    *
    * This method cannot fail, i.e., it will trigger a
    * NS_FATAL_ERROR if the requested GlobalValue is not found.
-   * 
+   *
    * \param [in] name the name of the GlobalValue to be found
    * \param [out] value where to store the value of the found GlobalValue
    */
   static void GetValueByName (std::string name, AttributeValue &value);
 
-
 private:
-  // Test case needs direct access to GetVector()
+  /** Test case needs direct access to GetVector() */
   friend class tests::GlobalValueTestCase;
 
   /**
@@ -192,7 +191,7 @@
    *
    * \returns The vector.
    */
-  static Vector *GetVector (void);
+  static Vector * GetVector (void);
   /** Initialize from the \c NS_GLOBAL_VALUE environment variable. */
   void InitializeFromEnv (void);
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/hash-fnv.cc ns-3.31/src/core/model/hash-fnv.cc
--- ns-3.30.1/src/core/model/hash-fnv.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/hash-fnv.cc	2020-06-27 17:38:30.000000000 -0700
@@ -51,7 +51,7 @@
 
 namespace Function {
 
-/** FNV hash implementation details. */  
+/** FNV hash implementation details. */
 namespace Fnv1aImplementation {
 
 /*************************************************
@@ -63,13 +63,13 @@
  * \defgroup hash_fnv FNV Hash Implementation
  */
 /**@{*/
-  
+
 extern "C" {
 
 // Changes from FNV distribution are marked with `//PDB'
 //
 
-// Begin fnv.h ----------------------------------->
+/* Begin fnv.h -------------- *NS_CHECK_STYLE_OFF* ----> */
 
 /*
  * fnv - Fowler/Noll/Vo- hash code
@@ -195,7 +195,7 @@
  */
 //#include "longlong.h"  //PDB - assume `unsigned long long' is 64 bit
 #define HAVE_64BIT_LONG_LONG  
-  
+
 
 
 /** 
@@ -292,9 +292,9 @@
 
 #endif /* __FNV_H__ */
 
-// End fnv.h ------------------------------->
+/* End fnv.h ---------------- *NS_CHECK_STYLE_ON* -----> */
 
-// Begin hash_32a.c ------------------------------>
+/* Begin hash_32a.c --------- *NS_CHECK_STYLE_OFF* ----> */
 
 /*
  * hash_32 - 32 bit Fowler/Noll/Vo FNV-1a hash code
@@ -438,10 +438,10 @@
     /* return our new hash value */
     return hval;
 }
-  
-// End hash_32a.c -------------------------->
 
-// Begin hash_64a.c------------------------------->
+/* End hash_32a.c ----------- *NS_CHECK_STYLE_ON* -----> */
+
+/* Begin hash_64a.c --------- *NS_CHECK_STYLE_OFF* ----> */
 
 /*
  * hash_64 - 64 bit Fowler/Noll/Vo-0 FNV-1a hash code
@@ -734,8 +734,8 @@
     /* return our new hash value */
     return hval;
 }
-  
-// End hash_64a.c--------------------------->
+
+/* End hash_64a.c ----------- *NS_CHECK_STYLE_ON* -----> */
 
 }  /* extern "C" */
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/hash-function.h ns-3.31/src/core/model/hash-function.h
--- ns-3.30.1/src/core/model/hash-function.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/hash-function.h	2020-06-27 17:38:30.000000000 -0700
@@ -86,14 +86,16 @@
   /**
    * Constructor.
    */
-  Implementation () { };
+  Implementation ()
+  { }
   /**
    * Destructor.
    */
-  virtual ~Implementation () { };
+  virtual ~Implementation ()
+  { }
 };  // Hashfunction
 
-  
+
 /*--------------------------------------
  *  Hash function implementation
  *  by function pointers and templates
@@ -132,12 +134,15 @@
    *
    * \param [in] hp Function pointer to a 32-bit hash function.
    */
-  Hash32 (Hash32Function_ptr hp) : m_fp (hp) { };
+  Hash32 (Hash32Function_ptr hp) : m_fp (hp)
+  { }
   uint32_t GetHash32 (const char * buffer, const std::size_t size)
   {
-    return (*m_fp) (buffer, size);
+    return (*m_fp)(buffer, size);
   }
-  void clear () { };
+  void clear ()
+  { }
+
 private:
   Hash32Function_ptr m_fp;  /**< The hash function. */
 };  // Hash32
@@ -156,10 +161,11 @@
    *
    * \param [in] hp Function pointer to a 64-bit hash function.
    */
-  Hash64 (Hash64Function_ptr hp) : m_fp (hp) { };
+  Hash64 (Hash64Function_ptr hp) : m_fp (hp)
+  { }
   uint64_t GetHash64 (const char * buffer, const std::size_t size)
   {
-    return (*m_fp) (buffer, size);
+    return (*m_fp)(buffer, size);
   }
   uint32_t GetHash32 (const char * buffer, const std::size_t size)
   {
@@ -169,7 +175,9 @@
     memcpy (&hash32, &hash64, sizeof (hash32));
     return hash32;
   }
-  void clear () { };
+  void clear ()
+  { }
+
 private:
   Hash64Function_ptr m_fp;  /**< The hash function. */
 };  // Hash64<Hash64Function_ptr>
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/hash-murmur3.cc ns-3.31/src/core/model/hash-murmur3.cc
--- ns-3.30.1/src/core/model/hash-murmur3.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/hash-murmur3.cc	2020-06-27 17:38:30.000000000 -0700
@@ -30,6 +30,7 @@
  * In addition comment blocks have been converted to Doxygen format.
  * Function arguments for buffer length which were originally
  * "int len" or "int i" have been changed to "std::size_t".
+ * In the _x86 versions the main loop used negative indexes, as shown.
  * Other conversions to std::size_t are marked.
  */
 
@@ -60,8 +61,8 @@
  * \defgroup hash_murmur3 Murmur3 Hash Implementation
  */
 /**@{*/
-  
-  
+
+
 // Changes from Murmur3 distribution are marked with `//PDB'
 //
 
@@ -71,7 +72,7 @@
 
 // Adapted from http://code.google.com/p/smhasher/
 
-// Begin Murmur3.cpp ----------------------------->
+// Begin Murmur3.cpp -------- *NS_CHECK_STYLE_OFF* ---->
 
 //
 //-----------------------------------------------------------------------------
@@ -126,7 +127,7 @@
 {
   return p[i];
 }
-/** \copydoc getblock(const uint32_t*,int) */
+/** \copydoc getblock(const uint32_t*,std::size_t) */
 inline uint64_t getblock ( const uint64_t * p, std::size_t i )
 {
   return p[i];
@@ -210,16 +211,18 @@
   //----------
   // body
 
-  const uint32_t * blocks = (const uint32_t *)(data + nblocks*4);
+  //PDB: const uint32_t * blocks = (const uint32_t *)(data + nblocks*4);
+  const uint32_t * blocks = (const uint32_t *)(data);
 
-  for(std::size_t i = -nblocks; i; i++)  //PDB: was int i
+  //PDB: for(int i = -nblocks; i; i++)
+  for(std::size_t i = 0; i < nblocks; i++)
   {
     uint32_t k1 = getblock(blocks,i);
 
     k1 *= c1;
     k1 = rotl32(k1,15);
     k1 *= c2;
-    
+
     h1 ^= k1;
     h1 = rotl32(h1,13); 
     h1 = h1*5+0xe6546b64;
@@ -320,9 +323,11 @@
   //----------
   // body
 
-  const uint32_t * blocks = (const uint32_t *)(data + nblocks*16);
+  //PDB: const uint32_t * blocks = (const uint32_t *)(data + nblocks*16);
+  const uint32_t * blocks = (const uint32_t *)(data);
 
-  for(std::size_t i = -nblocks; i; i++)  //PDB: was int i
+  //PDB: for(int i = -nblocks; i; i++)
+  for(std::size_t i = 0; i < nblocks; i++)
   {
     uint32_t k1 = getblock(blocks,i*4+0);
     uint32_t k2 = getblock(blocks,i*4+1);
@@ -399,7 +404,7 @@
   uint32_t h2 = seeds[1];
   uint32_t h3 = seeds[2];
   uint32_t h4 = seeds[3];
-  
+
   h1 ^= len; h2 ^= len; h3 ^= len; h4 ^= len;
 
   h1 += h2; h1 += h3; h1 += h4;
@@ -501,11 +506,11 @@
 }
 
 
-// End Murmur3.cpp ----------------------------->
+// End Murmur3.cpp ---------- *NS_CHECK_STYLE_ON* ----->
 
 #undef BIG_CONSTANT
 
-  
+
 //-----------------------------------------------------------------------------
 
 
@@ -525,10 +530,10 @@
   using namespace Murmur3Implementation;
 
   MurmurHash3_x86_32_incr (buffer, size,
-                           m_hash32, (void *)& m_hash32);
+                           m_hash32, (void *) &m_hash32);
   m_size32 += static_cast<uint32_t> (size);
   uint32_t hash;
-  MurmurHash3_x86_32_fin  (m_size32, m_hash32, (void *) & hash);
+  MurmurHash3_x86_32_fin  (m_size32, m_hash32, (void *) &hash);
 
   return hash;
 }
@@ -555,7 +560,7 @@
   //
   // Using uint32_t here avoids the bug, and continues to works with newer gcc.
   uint32_t hash[4];
-  
+
   MurmurHash3_x86_128_fin (static_cast<int> (m_size64),
                            (uint32_t *)(void *)m_hash64, hash);
   uint64_t result = hash[1];
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/heap-scheduler.h ns-3.31/src/core/model/heap-scheduler.h
--- ns-3.30.1/src/core/model/heap-scheduler.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/heap-scheduler.h	2020-06-27 17:38:30.000000000 -0700
@@ -39,7 +39,9 @@
  *
  * This code started as a c++ translation of a Java-based code written in 2005
  * to implement a heap sort. So, this binary heap is really a pretty
- * straightforward implementation of the classic data structure. Not much to say
+ * straightforward implementation of the classic data structure,
+ * implemented on a `std::vector`.  This implementation does not make use
+ * of any of the heap functions from the STL.  Not much to say
  * about it.
  *
  * What is smart about this code ?
@@ -49,6 +51,23 @@
  *    the index of the root is 1.
  *  - It uses a slightly non-standard while loop for top-down heapify
  *    to move one if statement out of the loop.
+ *
+ * \par Time Complexity
+ *
+ * Operation    | Amortized %Time | Reason
+ * :----------- | :-------------- | :-----
+ * Insert()     | Logarithmic     | Heapify
+ * IsEmpty()    | Constant        | Explicit queue size
+ * PeekNext()   | Constant        | Heap kept sorted
+ * Remove()     | Logarithmic     | Search, heapify
+ * RemoveNext() | Logarithmic     | Heapify
+ *
+ * \par Memory Complexity
+ *
+ * Category  | Memory                           | Reason
+ * :-------- | :------------------------------- | :-----
+ * Overhead  | 3 x `sizeof (*)`<br/>(24 bytes)  | `std::vector`
+ * Per Event | 0                                | Events stored in `std::vector` directly
  */
 class HeapScheduler : public Scheduler
 {
@@ -79,14 +98,14 @@
    * Get the parent index of a given entry.
    *
    * \param [in] id The child index.
-   * \return The index of the parent of \p id.
+   * \return The index of the parent of \pname{id}.
    */
   inline std::size_t Parent (std::size_t id) const;
   /**
    * Get the next sibling of a given entry.
    *
    * \param [in] id The starting index.
-   * \returns The next sibling of \p id.
+   * \returns The next sibling of \pname{id}.
    */
   std::size_t Sibling (std::size_t id) const;
   /**
@@ -118,7 +137,7 @@
    * Test if an index is the root.
    *
    * \param [in] id The index to test.
-   * \returns \c true if the \p id is the root.
+   * \returns \c true if the \pname{id} is the root.
    */
   inline bool IsRoot (std::size_t id) const;
   /**
@@ -151,7 +170,7 @@
    * \param [in] b The second item.
    */
   inline void Exch (std::size_t a, std::size_t b);
-  /** Percolate a newly inserted Last item to its proper position. */ 
+  /** Percolate a newly inserted Last item to its proper position. */
   void BottomUp (void);
   /**
    * Percolate a deletion bubble down the heap.
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/int64x64-128.cc ns-3.31/src/core/model/int64x64-128.cc
--- ns-3.30.1/src/core/model/int64x64-128.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/int64x64-128.cc	2020-06-27 17:38:30.000000000 -0700
@@ -46,7 +46,7 @@
  * \param [out] ub The unsigned magnitude of the second operand.
  * \returns \c true if the result will be negative.
  */
-static inline  
+static inline
 bool
 output_sign (const int128_t sa,
              const int128_t sb,
@@ -93,7 +93,7 @@
   // if the high part is not zero, put a warning
   NS_ABORT_MSG_IF ((hiPart & HP_MASK_HI) != 0,
                    "High precision 128 bits multiplication error: multiplication overflow.");
-  
+
   // Adding 64-bit terms to get 128-bit results, with carries
   res1 = loPart >> 64;
   res2 = midPart & HP_MASK_LO;
@@ -121,7 +121,7 @@
 uint128_t
 int64x64_t::Udiv (const uint128_t a, const uint128_t b)
 {
-  
+
   uint128_t rem = a;
   uint128_t den = b;
   uint128_t quo = rem / den;
@@ -131,36 +131,36 @@
   // Now, manage the remainder
   const uint64_t DIGITS = 64;  // Number of fraction digits (bits) we need
   const uint128_t ZERO = 0;
-  
+
   NS_ASSERT_MSG (rem < den,
                  "Remainder not less than divisor");
-  
+
   uint64_t digis = 0;          // Number of digits we have already
   uint64_t shift = 0;          // Number we are going to get this round
-  
-    // Skip trailing zeros in divisor
+
+  // Skip trailing zeros in divisor
   while ( (shift < DIGITS) && !(den & 0x1))
     {
       ++shift;
       den >>= 1;
     }
-  
+
   while ( (digis < DIGITS) && (rem != ZERO) )
     {
       // Skip leading zeros in remainder
-      while ( (digis + shift < DIGITS) &&
-              !(rem & HP128_MASK_HI_BIT))
-        {      
+      while ( (digis + shift < DIGITS)
+              && !(rem & HP128_MASK_HI_BIT))
+        {
           ++shift;
           rem <<= 1;
         }
 
       // Cast off denominator bits if:
       //   Need more digits and
-      //     LSB is zero or 
+      //     LSB is zero or
       //     rem < den
-      while ( (digis + shift < DIGITS) &&
-              ( !(den & 0x1) || (rem < den) ) )
+      while ( (digis + shift < DIGITS)
+              && ( !(den & 0x1) || (rem < den) ) )
         {
           ++shift;
           den >>= 1;
@@ -183,11 +183,11 @@
       shift = DIGITS - digis;
       result <<= shift;
     }
-  
+
   return result;
 }
 
-void 
+void
 int64x64_t::MulByInvert (const int64x64_t & o)
 {
   bool negResult = _v < 0;
@@ -213,7 +213,7 @@
   return result;
 }
 
-int64x64_t 
+int64x64_t
 int64x64_t::Invert (const uint64_t v)
 {
   NS_ASSERT (v > 1);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/int64x64-128.h ns-3.31/src/core/model/int64x64-128.h
--- ns-3.30.1/src/core/model/int64x64-128.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/int64x64-128.h	2020-06-27 17:38:30.000000000 -0700
@@ -33,7 +33,7 @@
 /**
  * \file
  * \ingroup highprec
- * Declaration of the ns3::int64x64_t type using a native int128_t type..
+ * Declaration of the ns3::int64x64_t type using a native int128_t type.
  */
 
 namespace ns3 {
@@ -45,7 +45,7 @@
 class int64x64_t
 {
   /// uint128_t high bit (sign bit).
-  static const uint128_t   HP128_MASK_HI_BIT = (((int128_t)1)<<127);
+  static const uint128_t   HP128_MASK_HI_BIT = (((int128_t)1) << 127);
   /// Mask for fraction part.
   static const uint64_t    HP_MASK_LO = 0xffffffffffffffffULL;
   /// Mask for sign + integer part.
@@ -73,7 +73,8 @@
    * specifically the double implementation.  To handle this,
    * we expose the underlying implementation type here.
    */
-  enum impl_type {
+  enum impl_type
+  {
     int128_impl,  //!< Native \c int128_t implementation.
     cairo_impl,   //!< Cairo wideint implementation.
     ld_impl,      //!< `long double` implementation.
@@ -84,7 +85,8 @@
 
   /// Default constructor.
   inline int64x64_t ()
-    : _v (0)  {}
+    : _v (0)
+  {}
   /**
    * \name Construct from a floating point value.
    *
@@ -117,8 +119,8 @@
     const uint64_t lo = flo;
     if (flo >= HP_MAX_64)
       {
-	// conversion to uint64 rolled over
-	++hi;
+        // conversion to uint64 rolled over
+        ++hi;
       }
     _v = hi << 64;
     _v |= lo;
@@ -138,12 +140,12 @@
     _v <<= 64;
   }
   inline int64x64_t (const long int v)
-    : _v (v) 
+    : _v (v)
   {
     _v <<= 64;
   }
   inline int64x64_t (const long long int v)
-    : _v (v) 
+    : _v (v)
   {
     _v <<= 64;
   }
@@ -153,17 +155,17 @@
     _v <<= 64;
   }
   inline int64x64_t (const unsigned long int v)
-    : _v (v) 
+    : _v (v)
   {
     _v <<= 64;
   }
   inline int64x64_t (const unsigned long long int v)
-    : _v (v) 
+    : _v (v)
   {
     _v <<= 64;
   }
   /**@}*/
-  
+
   /**
    * Construct from explicit high and low values.
    *
@@ -182,7 +184,8 @@
    * \param [in] o Value to copy.
    */
   inline int64x64_t (const int64x64_t & o)
-    : _v (o._v) {}
+    : _v (o._v)
+  {}
   /**
    * Assignment.
    *
@@ -259,24 +262,47 @@
 
 private:
 
+  /**
+   * \name Arithmetic Operators
+   * Arithmetic operators for int64x64_t.
+   */
+  /**
+   * @{
+   *  Arithmetic operator.
+   *  \param [in] lhs Left hand argument
+   *  \param [in] rhs Right hand argument
+   *  \return The result of the operator.
+   */
   friend bool         operator == (const int64x64_t & lhs, const int64x64_t & rhs);
 
   friend bool         operator <  (const int64x64_t & lhs, const int64x64_t & rhs);
   friend bool         operator >  (const int64x64_t & lhs, const int64x64_t & rhs);
-  
+
   friend int64x64_t & operator += (      int64x64_t & lhs, const int64x64_t & rhs);
   friend int64x64_t & operator -= (      int64x64_t & lhs, const int64x64_t & rhs);
   friend int64x64_t & operator *= (      int64x64_t & lhs, const int64x64_t & rhs);
   friend int64x64_t & operator /= (      int64x64_t & lhs, const int64x64_t & rhs);
+  /**@}*/
 
+  /**
+   * \name Unary Operators
+   * Unary operators for int64x64_t.
+   */
+  /**
+   * @{
+   *  Unary operator.
+   *  \param [in] lhs Left hand argument
+   *  \return The result of the operator.
+   */
   friend int64x64_t   operator -  (const int64x64_t & lhs);
   friend int64x64_t   operator !  (const int64x64_t & lhs);
+  /**@}*/
 
   /**
    * Implement `*=`.
    *
    * \param [in] o The other factor.
-   */   
+   */
   void Mul (const int64x64_t & o);
   /**
    * Implement `/=`.
@@ -334,7 +360,8 @@
    * \param [in] v Integer value to represent.
    */
   inline int64x64_t (const int128_t v)
-    : _v (v) {}
+    : _v (v)
+  {}
 
   int128_t _v;  //!< The Q64.64 value.
 
@@ -344,6 +371,9 @@
 /**
  * \ingroup highprec
  * Equality operator.
+ * \param [in] lhs Left hand argument
+ * \param [in] rhs Right hand argument
+ * \return The result of the operator.
  */
 inline bool operator == (const int64x64_t & lhs, const int64x64_t & rhs)
 {
@@ -352,6 +382,9 @@
 /**
  * \ingroup highprec
  * Less than operator.
+ * \param [in] lhs Left hand argument
+ * \param [in] rhs Right hand argument
+ * \return The result of the operator.
  */
 inline bool operator < (const int64x64_t & lhs, const int64x64_t & rhs)
 {
@@ -360,6 +393,9 @@
 /**
  * \ingroup highprec
  * Greater operator.
+ * \param [in] lhs Left hand argument
+ * \param [in] rhs Right hand argument
+ * \return The result of the operator.
  */
 inline bool operator > (const int64x64_t & lhs, const int64x64_t & rhs)
 {
@@ -369,6 +405,9 @@
 /**
  * \ingroup highprec
  * Compound addition operator.
+ * \param [in] lhs Left hand argument
+ * \param [in] rhs Right hand argument
+ * \return The result of the operator.
  */
 inline int64x64_t & operator += (int64x64_t & lhs, const int64x64_t & rhs)
 {
@@ -378,6 +417,9 @@
 /**
  * \ingroup highprec
  * Compound subtraction operator.
+ * \param [in] lhs Left hand argument
+ * \param [in] rhs Right hand argument
+ * \return The result of the operator.
  */
 inline int64x64_t & operator -= (int64x64_t & lhs, const int64x64_t & rhs)
 {
@@ -387,6 +429,9 @@
 /**
  * \ingroup highprec
  * Compound multiplication operator.
+ * \param [in] lhs Left hand argument
+ * \param [in] rhs Right hand argument
+ * \return The result of the operator.
  */
 inline int64x64_t & operator *= (int64x64_t & lhs, const int64x64_t & rhs)
 {
@@ -396,6 +441,9 @@
 /**
  * \ingroup highprec
  * Compound division operator.
+ * \param [in] lhs Left hand argument
+ * \param [in] rhs Right hand argument
+ * \return The result of the operator.
  */
 inline int64x64_t & operator /= (int64x64_t & lhs, const int64x64_t & rhs)
 {
@@ -406,6 +454,8 @@
 /**
  * \ingroup highprec
  * Unary plus operator.
+ * \param [in] lhs Left hand argument
+ * \return The result of the operator.
  */
 inline int64x64_t operator + (const int64x64_t & lhs)
 {
@@ -414,6 +464,8 @@
 /**
  * \ingroup highprec
  * Unary negation operator (change sign operator).
+ * \param [in] lhs Left hand argument
+ * \return The result of the operator.
  */
 inline int64x64_t operator - (const int64x64_t & lhs)
 {
@@ -422,6 +474,8 @@
 /**
  * \ingroup highprec
  * Logical not operator.
+ * \param [in] lhs Left hand argument
+ * \return The result of the operator.
  */
 inline int64x64_t operator ! (const int64x64_t & lhs)
 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/int64x64-cairo.cc ns-3.31/src/core/model/int64x64-cairo.cc
--- ns-3.30.1/src/core/model/int64x64-cairo.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/int64x64-cairo.cc	2020-06-27 17:38:30.000000000 -0700
@@ -54,7 +54,7 @@
  * \param [out] ub The unsigned magnitude of the second operand.
  * \returns True if the result will be negative.
  */
-static inline  
+static inline
 bool
 output_sign (const cairo_int128_t sa,
              const cairo_int128_t sb,
@@ -109,9 +109,9 @@
   res2 = _cairo_uint64_to_uint128 (hiPart.lo);
   res1 = _cairo_uint128_add (res1, res2);
   res1 = _cairo_uint128_lsl (res1, 64);
-  
+
   result  = _cairo_uint128_add (result, res1);
-  
+
   return result;
 }
 
@@ -135,36 +135,36 @@
   // Now, manage the remainder
   const uint64_t DIGITS = 64;  // Number of fraction digits (bits) we need
   const cairo_uint128_t ZERO = _cairo_uint32_to_uint128 ((uint32_t)0);
-  
+
   NS_ASSERT_MSG (_cairo_uint128_lt (rem, den),
                  "Remainder not less than divisor");
-  
+
   uint64_t digis = 0;          // Number of digits we have already
   uint64_t shift = 0;          // Number we are going to get this round
-  
-    // Skip trailing zeros in divisor
+
+  // Skip trailing zeros in divisor
   while ( (shift < DIGITS) && !(den.lo & 0x1))
     {
       ++shift;
       den = _cairo_uint128_rsl (den, 1);
     }
-  
-  while ( (digis < DIGITS) && !(_cairo_uint128_eq(rem, ZERO)) )
+
+  while ( (digis < DIGITS) && !(_cairo_uint128_eq (rem, ZERO)) )
     {
       // Skip leading zeros in remainder
-      while ( (digis + shift < DIGITS) &&
-              !(rem.hi & HPCAIRO_MASK_HI_BIT) )
-        {      
+      while ( (digis + shift < DIGITS)
+              && !(rem.hi & HPCAIRO_MASK_HI_BIT) )
+        {
           ++shift;
           rem = _cairo_int128_lsl (rem, 1);
         }
 
       // Cast off denominator bits if:
       //   Need more digits and
-      //     LSB is zero or 
+      //     LSB is zero or
       //     rem < den
-      while ( (digis + shift < DIGITS) &&
-              ( !(den.lo & 0x1) || _cairo_uint128_lt (rem, den) ) )
+      while ( (digis + shift < DIGITS)
+              && ( !(den.lo & 0x1) || _cairo_uint128_lt (rem, den) ) )
         {
           ++shift;
           den = _cairo_uint128_rsl (den, 1);
@@ -186,11 +186,11 @@
       shift = DIGITS - digis;
       result = _cairo_uint128_lsl (result, static_cast<int> (shift));
     }
-  
+
   return result;
 }
 
-void 
+void
 int64x64_t::MulByInvert (const int64x64_t & o)
 {
   bool sign = _cairo_int128_negative (_v);
@@ -199,7 +199,7 @@
 
   _v = sign ? _cairo_int128_negate (result) : result;
 }
-  
+
 cairo_uint128_t
 int64x64_t::UmulByInvert (const cairo_uint128_t a, const cairo_uint128_t b)
 {
@@ -214,7 +214,7 @@
   return result;
 }
 
-int64x64_t 
+int64x64_t
 int64x64_t::Invert (const uint64_t v)
 {
   NS_ASSERT (v > 1);
